{ Struktur der BBToss Area- und Link-Daten ab Programmversion 1.99}

{ Die Dateien sind prinzipiell wie folgt aufgebaut: }

{   +--------------------+
    | DATEIHEADER-RECORD |  Header vom Typ signrec
    +--------------------+
    | Datensaetze ...    |
    |             ...    |
    +--------------------+
    | DATEIHEADER-RECORD |  Wiederholung des Header-Records vom Anfang
    +--------------------+
}

Const
    DataRevisionLevel    = 1;    {Version der Datenstruktur}
                                 {berprfung in ReadCfg-Routinen}
    OldDataRevisionLevel = 0;

{Configfile-Namen}
  bbtosscfg      = 'bbtoss.cfg';   {Grundeinstellungen, Pfade und Flags}

  bbtlinkcfg     = 'bbtlink.bbt';  {Configdatei der Linkdaten (binr)}
  bbtareacfg     = 'bbtarea.bbt';  {Configdatei der Areadaten (binr)}

  bbtlinkini     = 'bbtlink.ini';  {Linkdaten als Textdatei}
  bbtareaini     = 'bbtarea.ini';  {Areadaten als Textdatei}

  bbtakacfg      = 'bbtaka.cfg';   {eingene Akas}
  bbtzipcfg      = 'bbtzip.cfg';   {Packer Pfade und Commandlines}
  bbtgroupcfg    = 'bbtgroup.cfg'; {Areagruppen Definitionen}
  bbtaliascfg    = 'bbtalias.cfg'; {Aliasnamen}
  bbtuplinkcfg   = 'bbtuplnk.cfg'; {Uplink-Einstellungen}
  bbtroutecfg    = 'bbtroute.cfg'; {Netmail Routing-Einstellungen}
  bbtnewareacfg  = 'bbtnewar.bbt'; {Zwischenspeicher fr neu bestellte Areas}
  bbtcrcfile     = 'bbtdupe.bbt';  {CRC Daten fr Dupe-Check}
  bbtsayerrfile  = 'btsayerr.bbt'; {Textfile fr Errormsgs BTSayerr}
  bbtlockfile    = 'bbtoss.bsy';   {wird bei Progende gelscht}

{----- Declarationen fr Links und Link-Record---------------------}
{Link Flag-Definitionen fr Link-Record}
link_activ        = $00000001;
link_checkpktpwd  = $00000002; {checkpktpwd}
link_sayerror     = $00000004; {automatische Nachricht bei Fehlern}
link_autocreate   = $00000008; {berechtigt zum anlegen neuer Areas}
link_forwardmgr   = $00000010; {Areamgr Requests forwarded zum uplink}
link_packnetmail  = $00000020; {netmail mit einpacken}
link_packholdnet  = $00000040; {netmail mit Hold-Status einpacken}
{platzhalter      = $00000080;}
link_autoconnect  = $00000100; {link zu neuen Areas automatisch connecten}

{----- Declarationen fr Areas und Area-Record----------------------}
{Arc-Mail Status Verwendung in Link-Record}
arcmail_hold   = 1;
arcmail_direct = 2;
arcmail_crash  = 4;

{Area Flags-Definitionen}
area_killseenby  = $00000001; {seen-by zeilen lschen}
area_killpath    = $00000002; {path-zeile zurcksetzen }
area_chkaka      = $00000008; {prfe Absender-Aka jeder Msg}
area_passive     = $00000010; {Area temporr passiv}
area_importseenby= $00000020; {import seenby in msgbase}
area_importpath  = $00000040; {import path in MsgBase}
area_excludebbs  = $00000080; {nicht in Box exportieren}
area_Pflichtarea = $00000100; {abmelden nicht mglich}

type  signstr = array[1..10] of char;  {Keyword in signrec}

const areasign : signstr = 'BBTAREACFG';
      linksign : signstr = 'BBTLINKCFG';

type signrec = record     {Vorspann in Bit-Cfg Files}
        sign : signstr;   {bbtarea.bbt & bbtlink.bbt}
        rev  : word;
        count: word;
        end;

String60 = String[60];

{
aktuelle Definitionen, in anderer Unit declariert ....

Pathstr  = String[79];

Addrtype = record
   Zone,
   Net,
   Node,
   Point : Word;
   end;
}

{verwendete Zeichen fr Packer -> LinkFileRec.Zipper}
{      Z = ZIP     }
{      A = ARC     }
{      L = LHA/LZH }
{      J = ARJ     }
{      S = SQZ     }
{      R = RAR     }
{      H = HYP     }
{      O = ZOO     }
{      U = UC2     }

LinkFileRec = Record
   Sysop   : string[40];   {Sysop-Name}
   NodeNr  : Addrtype;
   UseAka  : Addrtype;     {Absender Aka fr PKT-Files}
   PktPwd  : String[9];    {Packet Password}
   MgrPwd  : String[15];   {Areamgr Password}
   Level   : Word;         {Level des Links}
   Zipper  : char;         {Packer fr AcrMails Z=Zip J=ARJ A=ARC L=LHA...}
   Group   : String[15];   {Buchstabe der angeschlossenen Gruppen A..Z,a..z}
   Arcmailstatus: byte;    {normal hold direct crash..siehe arcmail_xxx}
   Capability   : Word;    {Packetformat, Type 2 type 2+ usw. (aktuell not used)}
   Flags   : longint;      {Link-Flags, siehe link_xxxx Konstanten}
   Flow    : longint;      {Anzahl gesendeter Echomails (aktuell not used)}
   KB      : longint;      {Anzahl Bytes gesendeter Echomails}
   end;

{
Aufbau Area-Datei
   signrec
      areafilerec
        array [1..storedlinks] of integer;
      areafilerec
        array [1..storedlinks] of integer;
     ...
     ...
   signrec
dem Areafilerec folgen also storedlinks  Integer-Zahlen  welche den
x-ten Link im Linkfile bezeichnet (1. Link im Linkfile = Nr. 1}

{verwendete Zeichen fr Messagebasetype -> AreaFileRec.Basetyp}
{   E = EzyCom              }
{   H = Hudson              }
{   J = JAM                 }
{   N = Fido Netmail *.MSG  }
{   S = Squish              }
{   P = Passthrough         }

{verwendete Zeichen fr Area-Typ -> AreaFileRec.Typ}
{   B = Badmail Area }
{   D = Dupemail Area}
{   E = Echo Area    }
{   L = lokales Area (also ohne Links)}
{   N = Netmail}

AreaFileRec = Record
   TagName    : String60;  {Echo-Area Name}
   Nr         : word;      {Nr. des Messagearea (in der Mailbox)}
   MPath      : pathstr;   {Msgbasename, bei Hudson '' (mu mit \ enden)}
   BaseTyp    : char;      {Msg-Basetype  J=Jam H=Hudson S=Squish N=*.msg}
   Group      : char;      {Gruppe des Areas  A..Z,a..z,0..9}
   Typ        : char;      {E=Echo L=Lokal B=Bad D=Dupe}
   MainAka    : addrtype;  {eigene Aka fr das Area}
   Flags      : longint;   {Area-Flags}
   WriteLevel : word;      {Schreiblevel }
   ReadLevel  : word;      {Lese/Bestell-Level}
   MaxMsgs    : word;      {max Anzahl Msgs fr Clean}
   MinMsgs    : word;      {min Anzahl Msgs fr Clean}
   DaysOld    : word;      {Anzahl Tage fr Clean}
   DaysRcvd   : Word;      {Anzahl Tage fr Clean}
   Flow       : Longint;   {Anzahl verarbeiteter Msgs seit StatDate}
   Desc       : String60;  {Beschreibung fr Area}
   DOrigin    : String60;  {Origin Zeile}
   StatDate   : Longint;   {StatistikDate (Julian)}
   dummy1     : Longint;
   StoredLinks: word;      {anzahl aktuell angeschlossener Links}
   end;
